#include "stdafx.h"

#include <stdio.h>
#include <conio.h>
#include <tchar.h>
#include <windows.h>
#include <wincrypt.h>
#include <winerror.h>

// Link with the Crypt32.lib file.
#pragma comment (lib, "Crypt32")

unsigned char *pbTimeStampData = NULL;
DWORD cbTimeStampData = 0;
unsigned char *pbSignedMessage = NULL;
DWORD cbSignedMessage = 0;
FILETIME ftTimeStamp;
#define MAX_NAME  128

unsigned char *pbMessage = NULL;
DWORD cbMessage = 0;
unsigned char pbEncodedDigest[256]; // 2048-bit key
DWORD cbEncodedDigest=256;
unsigned char pbHashValue[20];
DWORD cbHashValue=20;
TCHAR *tszSignerName;
unsigned char pbSignedHash[256];
DWORD cbSignedHash=256;

unsigned char Watermark[52];

const char *dotNetProtector = "dotNet Protector";
const char *runtime = "dotNet Protector Runtime *PvLog*";

int verbose=0;

TCHAR *GetCertDisplayName(PCCERT_CONTEXT pCertContext, TCHAR *pszNameString, DWORD cchNameString)
{
	if(CertGetNameString(pCertContext,CERT_NAME_SIMPLE_DISPLAY_TYPE,0,NULL,pszNameString,cchNameString)<2) return NULL;
	return pszNameString;
}

DWORD VerifyCertificate(PCCERT_CONTEXT pCertContext, LPFILETIME pTime)
{
	CERT_ENHKEY_USAGE        EnhkeyUsage;
	CERT_USAGE_MATCH         CertUsage;  
	CERT_CHAIN_PARA          ChainPara;
	PCCERT_CHAIN_CONTEXT     pChainContext;


	memset(&ChainPara,0,sizeof(CERT_CHAIN_PARA));
	EnhkeyUsage.cUsageIdentifier = 0;
	EnhkeyUsage.rgpszUsageIdentifier=NULL;
	CertUsage.dwType = USAGE_MATCH_TYPE_AND;
	CertUsage.Usage  = EnhkeyUsage;
	ChainPara.cbSize = sizeof(CERT_CHAIN_PARA);
	ChainPara.RequestedUsage=CertUsage;

	if(!CertGetCertificateChain(NULL,pCertContext,pTime,NULL,&ChainPara,0,NULL,&pChainContext))
	{
		return ~0;
	}
	DWORD dwStatus = pChainContext->TrustStatus.dwErrorStatus;
	CertFreeCertificateChain(pChainContext);
	return dwStatus;
}

int VerifyTimeStamp()
{
	PCRYPT_TIMESTAMP_CONTEXT pTsContext;
	PCCERT_CONTEXT pTsSigner;
	SYSTEMTIME st;
	TCHAR pszNameString[256];

	if(!CryptVerifyTimeStampSignature(pbTimeStampData,cbTimeStampData,pbEncodedDigest,cbEncodedDigest,NULL,&pTsContext,&pTsSigner,NULL)) return 0;
	memcpy(&ftTimeStamp,&pTsContext->pTimeStamp->ftTime,sizeof(FILETIME));
	FileTimeToSystemTime(&pTsContext->pTimeStamp->ftTime,&st);
	printf("Timestamp verified, ts time : %02d/%02d/%04d %02d:%02d:%02d.%03d\n",st.wDay,st.wMonth,st.wYear,st.wHour,st.wMinute,st.wSecond,st.wMilliseconds);
	DWORD dwTrustStatus = VerifyCertificate(pTsSigner,&pTsContext->pTimeStamp->ftTime);
	if(verbose) printf("Timestamp trust status=%d\n",dwTrustStatus);
	if(dwTrustStatus==0)
	{
		TCHAR *DisplayName=GetCertDisplayName(pTsSigner,pszNameString,255);
		if(DisplayName) 
		{
        if(verbose) _tprintf(
            TEXT("The SIMPLE_DISPLAY_TYPE TSA's name is ")
            TEXT("<<%s>> \n"),
            pszNameString);
		}
	}
	CertFreeCertificateContext (pTsSigner);
	CryptMemFree(pTsContext);
	return 1;
}

int VerifyMessageSignature()
{
    CRYPT_VERIFY_MESSAGE_PARA VerifyParams;
    BYTE *pbDecodedMessageBlob = NULL;
	TCHAR pszNameString[256];

    // Initialize the VerifyParams data structure.
    VerifyParams.cbSize = sizeof(CRYPT_VERIFY_MESSAGE_PARA);
    VerifyParams.dwMsgAndCertEncodingType = PKCS_7_ASN_ENCODING | X509_ASN_ENCODING;
    VerifyParams.hCryptProv = 0;
    VerifyParams.pfnGetSignerCertificate = NULL;
    VerifyParams.pvGetArg = NULL;

	PCCERT_CONTEXT pSignerCert;

	if(!CryptVerifyMessageSignature(&VerifyParams,0,pbSignedMessage,cbSignedMessage,pbMessage,&cbMessage,&pSignerCert)) 
	{
		return 0;
	}
	pbMessage = new unsigned char[cbMessage];
	if(!CryptVerifyMessageSignature(&VerifyParams,0,pbSignedMessage,cbSignedMessage,pbMessage,&cbMessage,&pSignerCert)) 
	{
		return 0;
	}
	DWORD dwTrustStatus = VerifyCertificate(pSignerCert,&ftTimeStamp);
	if(verbose) printf("Signature trust status=%d\n",dwTrustStatus);
	if(dwTrustStatus==0)
	{
		TCHAR *DisplayName=GetCertDisplayName(pSignerCert,pszNameString,255);
		if(DisplayName) 
		{
			if(verbose) _tprintf(
				TEXT("The SIMPLE_DISPLAY_TYPE Signer's name is ")
				TEXT("<<%s>> \n"),
				pszNameString);
			tszSignerName = new TCHAR[_tcslen(pszNameString)+1];
			_tcscpy(tszSignerName,DisplayName);
		}
	}
	CertFreeCertificateContext (pSignerCert);
	free(pbDecodedMessageBlob);
	return 1;
}

// Extract Digest, Signer Info, RFC3161 time-stamp from signed message
void DecomposeMessage()
{
	HCRYPTMSG hMsg=NULL;
	PCMSG_SIGNER_INFO pSignerInfo = NULL;
	PCMSG_SIGNER_INFO pCounterSignerInfo = NULL;
	DWORD dwSignerInfo;

	hMsg = CryptMsgOpenToDecode(PKCS_7_ASN_ENCODING | X509_ASN_ENCODING,CMSG_SIGNED,0,NULL,NULL,NULL);
	// Get message handle and store handle from the signed file.
	if (!hMsg)
	{
		_tprintf(_T("CryptMsgOpenToDecode failed with %x\n"), GetLastError());
        goto exit_DecomposeMessage;
	}
	BOOL fResult = CryptMsgUpdate(hMsg, pbSignedMessage, cbSignedMessage,1);
	if (!fResult)
	{
		_tprintf(_T("CryptMsgUpdate failed with %x\n"), GetLastError());
        goto exit_DecomposeMessage;
	}
	fResult = CryptMsgGetParam(hMsg,CMSG_ENCRYPTED_DIGEST, 0, pbEncodedDigest, &cbEncodedDigest);
	if (!fResult)
	{
		_tprintf(_T("CryptMsgGetParam CMSG_ENCRYPTED_DIGEST failed with %d\n"), GetLastError());
		goto exit_DecomposeMessage;
	}
	fResult = CryptMsgGetParam(hMsg, 
		CMSG_SIGNER_INFO_PARAM, 
		0, 
		NULL, 
		&dwSignerInfo);
	if (!fResult)
	{
		_tprintf(_T("CryptMsgGetParam failed with %x\n"), GetLastError());
		goto exit_DecomposeMessage;
	}

	// Allocate memory for signer information.
	pSignerInfo = (PCMSG_SIGNER_INFO)LocalAlloc(LPTR, dwSignerInfo);
	if (!pSignerInfo)
	{
		_tprintf(_T("Unable to allocate memory for Signer Info.\n"));
		goto exit_DecomposeMessage;
	}

	// Get Signer Information.
	fResult = CryptMsgGetParam(hMsg, 
		CMSG_SIGNER_INFO_PARAM, 
		0, 
		(PVOID)pSignerInfo, 
		&dwSignerInfo);
	if (!fResult)
	{
		_tprintf(_T("CryptMsgGetParam failed with %x\n"), GetLastError());
		goto exit_DecomposeMessage;
	}
	for (DWORD n = 0; n < pSignerInfo->UnauthAttrs.cAttr; n++)
	{           
		if (lstrcmpA("1.2.840.113549.1.9.16.1.4", pSignerInfo->UnauthAttrs.rgAttr[n].pszObjId) == 0) 
		{
			cbTimeStampData=pSignerInfo->UnauthAttrs.rgAttr[n].rgValue[0].cbData;
			pbTimeStampData = new unsigned char[cbTimeStampData];
			memcpy(pbTimeStampData,pSignerInfo->UnauthAttrs.rgAttr[n].rgValue[0].pbData,cbTimeStampData);
			break;
		}
	}
	
	exit_DecomposeMessage:
	if(pSignerInfo) LocalFree(pSignerInfo);
	if(hMsg) CryptMsgClose(hMsg);
}

int compare( const void *arg1, const void *arg2 )
{
	return *(int*)(arg1) - *(int*)(arg2);
}

// PE File Fragmants for Authenticode like Hash (Pvlog Runtime Hash)
PIMAGE_DATA_DIRECTORY ComputeFragments(HANDLE hFile, DWORD *pSizeOfHeaders, DWORD *pSiseOfSecData, DWORD *pOffsetOfSecData)
{
	DWORD dwJunk;
	IMAGE_DOS_HEADER DosHeader;
	IMAGE_FILE_HEADER FileHeader;
	IMAGE_OPTIONAL_HEADER32 OptHdr;
	DWORD SizeOfHeaders;
	DWORD ChecksumOffset;
	DWORD OptHdrOffset;
	DWORD SectOffset;
	DWORD SecDirOffset;
	IMAGE_DATA_DIRECTORY SecDirectory;
	IMAGE_SECTION_HEADER *Sections;
	int frags;

	*pOffsetOfSecData=0;
	ReadFile(hFile,&DosHeader,sizeof(IMAGE_DOS_HEADER),&dwJunk,NULL);
	OptHdrOffset = DosHeader.e_lfanew+0x18;
	ChecksumOffset = OptHdrOffset+0x40;
	SetFilePointer(hFile,DosHeader.e_lfanew+4,NULL,FILE_BEGIN);
	ReadFile(hFile,&FileHeader,sizeof(FileHeader),&dwJunk,NULL);
	ReadFile(hFile,&OptHdr,sizeof(OptHdr),&dwJunk,NULL);
	SizeOfHeaders=OptHdr.SizeOfHeaders;
	if(OptHdr.Magic==IMAGE_NT_OPTIONAL_HDR32_MAGIC) {
		SectOffset = OptHdrOffset+0x60+(OptHdr.NumberOfRvaAndSizes << 3);
		SecDirOffset = OptHdrOffset+0x80;
	} else if(OptHdr.Magic=IMAGE_NT_OPTIONAL_HDR64_MAGIC) {
		SetFilePointer(hFile,OptHdrOffset+0x6C,NULL,FILE_BEGIN);
		ReadFile(hFile,&OptHdr.NumberOfRvaAndSizes,4,&dwJunk,NULL);
		SectOffset = OptHdrOffset+0x70+(OptHdr.NumberOfRvaAndSizes << 3);
		SecDirOffset = OptHdrOffset+0x90;
	}
	if(OptHdr.NumberOfRvaAndSizes<0x10) return NULL;
	SetFilePointer(hFile,SecDirOffset,NULL,FILE_BEGIN);
	ReadFile(hFile,&SecDirectory,sizeof(SecDirectory),&dwJunk,NULL);
	Sections = new IMAGE_SECTION_HEADER[FileHeader.NumberOfSections];
	SetFilePointer(hFile,SectOffset,NULL,FILE_BEGIN);
	ReadFile(hFile,Sections,sizeof(IMAGE_SECTION_HEADER)*FileHeader.NumberOfSections,&dwJunk,NULL);
	frags = 6;
	for(int i=0; i<FileHeader.NumberOfSections; i++) if(Sections[i].SizeOfRawData) frags++;
	PIMAGE_DATA_DIRECTORY Fragments = new IMAGE_DATA_DIRECTORY[frags];
	PIMAGE_DATA_DIRECTORY pf = Fragments;

	*pSizeOfHeaders=SizeOfHeaders;
	*pSiseOfSecData=SecDirectory.Size;
	*pOffsetOfSecData = SecDirectory.VirtualAddress;

	// 1st fragment from begining to checksum
	pf->VirtualAddress=0;
	pf->Size=ChecksumOffset;
	pf++;
	// 2nd fragment from just-after checksum to security directory
	pf->VirtualAddress=ChecksumOffset+4;
	pf->Size=SecDirOffset - pf->VirtualAddress;;
	pf++;
	// 3rd fragment from just-after security directory to 0x380 
	pf->VirtualAddress=SecDirOffset+8;
	pf->Size=0x380-pf->VirtualAddress;
	pf++;
	// 4th fragment from 0x3A8 to end of headers
	pf->VirtualAddress=0x3A8;
	pf->Size=OptHdr.SizeOfHeaders-pf->VirtualAddress;
	pf++;
	frags=4;
	for(int i=0; i<FileHeader.NumberOfSections; i++)
	{
		if(!Sections[i].SizeOfRawData) continue;
		if(Sections[i].PointerToRawData<=SecDirectory.VirtualAddress && Sections[i].PointerToRawData+Sections[i].SizeOfRawData>SecDirectory.VirtualAddress) {
			pf->Size=SecDirectory.VirtualAddress-Sections[i].PointerToRawData;
			if(pf->Size) {
				pf->VirtualAddress=Sections[i].PointerToRawData;
				pf++; frags++;
			}
			pf->Size=Sections[i].SizeOfRawData-pf->Size-SecDirectory.Size;
			if(pf->Size) {
				pf->VirtualAddress=Sections[i].PointerToRawData+Sections[i].SizeOfRawData-pf->Size;
				pf++; frags++;
			}
		} else {
			pf->VirtualAddress=Sections[i].PointerToRawData;
			pf->Size=Sections[i].SizeOfRawData;
			pf++; frags++;
		}
	}
	delete Sections;
	Fragments[frags].Size=0;
	Fragments[frags].VirtualAddress=0;
	qsort(Fragments,frags,sizeof(IMAGE_DATA_DIRECTORY),&compare);
	return Fragments;
}

// Compute PvLog Hash
int CalcHashPvlog(HANDLE hFile, DWORD SiseOfPvLogData)
{
	
	DWORD dwJunk;
	HCRYPTPROV	hCryptProv;
	HCRYPTHASH	hHash;
	unsigned	iHashAlg = 0x8004;
	DWORD SizeOfHeaders=0;
	DWORD SiseOfSecData=0;
	DWORD OffsetOfSecData;
	DWORD FileSize, FileSizeHigh;

	SetFilePointer(hFile,0,NULL,FILE_BEGIN);
	FileSize = GetFileSize(hFile,&FileSizeHigh);
	PIMAGE_DATA_DIRECTORY Fragments = ComputeFragments(hFile, &SizeOfHeaders, &SiseOfSecData, &OffsetOfSecData);
	if(!Fragments)
	{
		printf("invalid PE file\n");
		CloseHandle(hFile);
		return 0;
	}
	CryptAcquireContext(&hCryptProv,NULL,NULL,PROV_RSA_FULL,CRYPT_VERIFYCONTEXT);
	CryptCreateHash(hCryptProv,CALG_SHA1,NULL,0,&hHash);
	DWORD SumOfBytesHashed = SizeOfHeaders;
	for(PIMAGE_DATA_DIRECTORY pf = Fragments; pf->Size!=0 || pf->VirtualAddress!=0; pf++)
	{
		SetFilePointer(hFile,pf->VirtualAddress,NULL,FILE_BEGIN);
		unsigned char *data = new unsigned char[pf->Size];
		ReadFile(hFile,data,pf->Size,&dwJunk,NULL);
		CryptHashData(hHash,data,pf->Size,0);
		delete data;
		if(pf>=&Fragments[4]) SumOfBytesHashed+=pf->Size;
	}
	if(FileSize>SumOfBytesHashed)
	{
		int sz = FileSize - SumOfBytesHashed - SiseOfSecData - SiseOfPvLogData;
		if(sz) 
		{
			unsigned char *data = new unsigned char[sz];
			ReadFile(hFile,data,sz,&dwJunk,NULL);
			CryptHashData(hHash,data,sz,0);
			delete data;
		}
	}
	CryptGetHashParam(hHash,HP_HASHVAL,pbHashValue,&cbHashValue,0);
	CryptDestroyHash(hHash);
	CryptReleaseContext(hCryptProv,0);
	if(verbose)
	{
		printf("SHA Hash : ");
		for(int i=0; i<20; i++) printf(" %02X",pbHashValue[i]);
		printf("\n");
	}
	return 1;
}


void PrintError(char *msg)
{
	DWORD dwErr = GetLastError();
	printf("%s -- Error %d (0x%08X)\n",msg,dwErr,dwErr);
}

// Verify Hash with the extracted public key blob
int VerifyHashWithKeyblob()
{
	BOOL rv;
	int step = 0;

	HCRYPTPROV	hCryptProv=0;
	HCRYPTHASH	hHash;
	unsigned	iHashAlg = 0x8004;

	DWORD cbSignedHash=256;

	// Verif
	HCRYPTKEY	hPubKey=0;
	DWORD dwErr = 0;
	rv = CryptAcquireContext(&hCryptProv,NULL,NULL,PROV_RSA_FULL,CRYPT_VERIFYCONTEXT);
	if(!rv) { printf("CryptAcquireContext failed with %x\n",GetLastError()); goto exit_DecodeHashWithKeyblob; }
	rv = CryptImportKey(hCryptProv,pbMessage,cbMessage,NULL,0,&hPubKey);
	if(!rv) { printf("CryptImportKey failed with %x\n",GetLastError()); goto exit_DecodeHashWithKeyblob; }
	rv=CryptCreateHash(hCryptProv,CALG_SHA1,NULL,0,&hHash);
	if(!rv) { printf("CryptCreateHash failed with %x\n",GetLastError()); goto exit_DecodeHashWithKeyblob; }
	rv=CryptHashData(hHash,Watermark,sizeof(Watermark),0);
	if(!rv) { printf("CryptHashData failed with %x\n",GetLastError()); goto exit_DecodeHashWithKeyblob; }
	rv=CryptVerifySignature(hHash,pbSignedHash,cbSignedHash,hPubKey,NULL,0);
	if(!rv) printf("CryptVerifySignature failed with %x\n",GetLastError());

	exit_DecodeHashWithKeyblob:
	if(hHash) CryptDestroyHash(hHash);
	if(hPubKey) CryptDestroyKey(hPubKey);
	if(hCryptProv) CryptReleaseContext(hCryptProv,0);

	return rv;
}

void ComputeStrongNameShaHash(HANDLE hFile, unsigned char *pbHash, DWORD *pcbHash)
{
	HCRYPTPROV	hCryptProv;
	HCRYPTHASH	hHash;
	unsigned	iHashAlg = 0x8004;
	DWORD dwJunk;
	IMAGE_DOS_HEADER *pDosHeader;
	IMAGE_NT_HEADERS32 *pNtHdr32;
	IMAGE_NT_HEADERS64 *pNtHdr64;
	IMAGE_SECTION_HEADER *Sections;
	DWORD NtHdrOffset;
	IMAGE_COR20_HEADER *pCliHeader;
	DWORD CliHeaderRva=0;
	DWORD pbStrongNameSignature=0;
	DWORD cbStrongNameSignature=0;
	PIMAGE_FILE_HEADER pFileHeader;
	unsigned char *pCurrent;
	unsigned char *pbFile;
	DWORD cbFile;
	LARGE_INTEGER FilePos;

	cbFile = GetFileSize(hFile,NULL);
	pbFile = new unsigned char[cbFile];
	FilePos.HighPart=FilePos.LowPart=0;
	SetFilePointerEx(hFile,FilePos,&FilePos,FILE_CURRENT);
	SetFilePointer(hFile,0,NULL,FILE_BEGIN);
	ReadFile(hFile,pbFile,cbFile,&dwJunk,NULL);
	SetFilePointerEx(hFile,FilePos,NULL,FILE_BEGIN);

	CryptAcquireContext(&hCryptProv,NULL,NULL,PROV_RSA_FULL,CRYPT_VERIFYCONTEXT);
	CryptCreateHash(hCryptProv,CALG_SHA1,NULL,0,&hHash);

	pCurrent = pbFile;
	pDosHeader=(PIMAGE_DOS_HEADER)pbFile;
	NtHdrOffset = pDosHeader->e_lfanew;
	pCurrent += NtHdrOffset;

	CryptHashData(hHash,pbFile,NtHdrOffset,0);

	pNtHdr32 = (PIMAGE_NT_HEADERS32)(pbFile+NtHdrOffset);
	if(pNtHdr32->OptionalHeader.Magic==IMAGE_NT_OPTIONAL_HDR32_MAGIC)
	{
		pNtHdr32->OptionalHeader.CheckSum=0;
		pNtHdr32->OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_SECURITY].VirtualAddress = 0;
		pNtHdr32->OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_SECURITY].Size = 0;
		CliHeaderRva = pNtHdr32->OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_COM_DESCRIPTOR].VirtualAddress;
		CryptHashData(hHash,(BYTE*)pNtHdr32,sizeof(IMAGE_NT_HEADERS32),0);
		pFileHeader = &pNtHdr32->FileHeader;
		pCurrent += sizeof(IMAGE_NT_HEADERS32);
	}
	else
	{
		pNtHdr64 = (PIMAGE_NT_HEADERS64)pNtHdr32;
		pNtHdr64->OptionalHeader.CheckSum=0;
		pNtHdr64->OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_SECURITY].VirtualAddress = 0;
		pNtHdr64->OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_SECURITY].Size = 0;
		CliHeaderRva = pNtHdr64->OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_COM_DESCRIPTOR].VirtualAddress;
		CryptHashData(hHash,(BYTE*)pNtHdr64,sizeof(IMAGE_NT_HEADERS64),0);
		pFileHeader = &pNtHdr64->FileHeader;
		pCurrent += sizeof(IMAGE_NT_HEADERS64);
	}
	Sections = (PIMAGE_SECTION_HEADER)pCurrent;
	CryptHashData(hHash,(BYTE*)Sections,sizeof(IMAGE_SECTION_HEADER)*pFileHeader->NumberOfSections,0);
	if(CliHeaderRva)
	{
		for(int i=0; i<pFileHeader->NumberOfSections; i++)
		{
			if(CliHeaderRva>=Sections[i].VirtualAddress && (CliHeaderRva+sizeof(IMAGE_COR20_HEADER))<(Sections[i].VirtualAddress+Sections[i].SizeOfRawData))
			{
				DWORD fileOffset = CliHeaderRva-Sections[i].VirtualAddress+Sections[i].PointerToRawData;
				pCliHeader = (PIMAGE_COR20_HEADER)(pbFile+fileOffset);
				cbStrongNameSignature = pCliHeader->StrongNameSignature.Size;
				pbStrongNameSignature = pCliHeader->StrongNameSignature.VirtualAddress;
				pCliHeader->Flags |= 8;
			}
		}
	}
	for(int i=0; i<pFileHeader->NumberOfSections; i++)
	{
		unsigned char *pbData;
		DWORD cbData;
		if(Sections[i].VirtualAddress>pbStrongNameSignature || Sections[i].VirtualAddress+Sections[i].SizeOfRawData<pbStrongNameSignature)
		{
			cbData = Sections[i].SizeOfRawData;
			pbData = pbFile + Sections[i].PointerToRawData;
			CryptHashData(hHash,pbData,cbData,0);
		}
		else if(Sections[i].VirtualAddress==pbStrongNameSignature && Sections[i].SizeOfRawData==cbStrongNameSignature) continue;
		else if(Sections[i].VirtualAddress==pbStrongNameSignature)
		{
			cbData = Sections[i].SizeOfRawData-cbStrongNameSignature;
			pbData = pbFile+Sections[i].PointerToRawData + cbStrongNameSignature;
			CryptHashData(hHash,pbData,cbData,0);
		}
		else if((pbStrongNameSignature+cbStrongNameSignature)==(Sections[i].VirtualAddress+Sections[i].SizeOfRawData))
		{
			cbData = Sections[i].SizeOfRawData-cbStrongNameSignature;
			pbData = pbFile+Sections[i].PointerToRawData;
			CryptHashData(hHash,pbData,cbData,0);
		}
		else
		{
			cbData = pbStrongNameSignature - Sections[i].VirtualAddress;
			pbData = pbFile+Sections[i].PointerToRawData;
			CryptHashData(hHash,pbData,cbData,0);
			cbData = Sections[i].SizeOfRawData-cbData-cbStrongNameSignature;
			pbData = pbFile + Sections[i].PointerToRawData + Sections[i].SizeOfRawData - cbData;
			CryptHashData(hHash,pbData,cbData,0);
		}
	}
	CryptGetHashParam(hHash,HP_HASHVAL,pbHash,pcbHash,0);
	CryptDestroyHash(hHash);
	CryptReleaseContext(hCryptProv,0);
}

int _tmain(int argc, _TCHAR* argv[])
{
	unsigned IsCustomer = 0;
	DWORD dwJunk;
	unsigned	iHashAlg = 0x8004;
	DWORD		cbHash=20;
	_TCHAR*		filename = argv[1];
	
	if(argc>2)
	{
		for(int i=1; i<argc; i++)
		{
			if(!_wcsicmp(argv[i],L"-v")) verbose=1; else filename=argv[i];
		}
	}

	HANDLE hFile=CreateFile(filename,GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
	SetFilePointer(hFile,0x380,NULL,FILE_BEGIN);
	ReadFile(hFile,Watermark,32,&dwJunk,NULL);
	if(!memcmp(Watermark,runtime,32))
	{
		DWORD msgOffset;
		printf("Authenticating PvLog dotNet Protector Runtime\n");
		// Get File Offset of Signed-CMS
		ReadFile(hFile,&msgOffset,4,&dwJunk,NULL);
		// Get Byte length of Signed-CMS
		ReadFile(hFile,&cbSignedMessage,4,&dwJunk,NULL);
		// Compute File Hash
		CalcHashPvlog(hFile,cbSignedMessage);
		// Read Signed-CMS
		SetFilePointer(hFile,msgOffset,NULL,FILE_BEGIN);
		pbSignedMessage = new unsigned char[cbSignedMessage];
		ReadFile(hFile,pbSignedMessage,cbSignedMessage,&dwJunk,NULL);
	}
	else if(!memcmp(Watermark,dotNetProtector,16))
	{
		printf("Authenticating dotNet Protector Protected Assembly\n");

		unsigned __int64 licenseHint, computerHint;
		memcpy(&licenseHint, Watermark+16, 8);
		memcpy(&computerHint, Watermark+24, 8);
		if(!licenseHint) printf("unlicensed demo"); else printf("Licensed %X",licenseHint);
		printf(" - computer hint : %X\n",computerHint);
		ComputeStrongNameShaHash(hFile,Watermark+32,&cbHash);
		// Read encrypted hash
		ReadFile(hFile,pbSignedHash,cbSignedHash,&dwJunk,NULL);
		DWORD dwBlobSize;
		ReadFile(hFile,&dwBlobSize,4,&dwJunk,NULL);
		if((dwBlobSize & 0xFFFF)!=0x8230)
		{
			printf("Bad Format\n");
			return 0;
		}
		cbSignedMessage = (dwBlobSize >> 24) | ((dwBlobSize >> 8) & 0xFF00);
		cbSignedMessage += 4;
		pbSignedMessage = new unsigned char[cbSignedMessage];
		SetFilePointer(hFile,0x4A0,NULL,FILE_BEGIN);
		ReadFile(hFile,pbSignedMessage,cbSignedMessage,&dwJunk,NULL);
		IsCustomer=1;
	}
	else
	{
		printf("no Pvlog Signature found\n");
		CloseHandle(hFile);
		return 0;
	}

	CloseHandle(hFile);

	DecomposeMessage();
	if(!VerifyTimeStamp())
	{
		printf("Timestamp verification failed\n");
		return 0;
	}
	if(!VerifyMessageSignature())
	{
		printf("Signature verification failed\n");
		return 0;
	}

	// Verify Signer
	if(_wcsicmp(tszSignerName,L"PV Logiciels"))
	{
		printf("NOT GENUINE - NOT Signed by PV Logiciels\n");
		return 0;
	}
	if(IsCustomer)
	{
		// Decrypting Hash 
		if(!VerifyHashWithKeyblob())
		{
			printf("NOT GENUINE\n");
			return 0;
		}
	} else {
		if(memcmp(pbHashValue,pbMessage,cbHashValue))
		{
			printf("NOT GENUINE - Hashes don't match\n");
			//if(verbose)
			//{
			//	printf("Computed Hash : ");
			//	for(int i=0; i<20; i++) printf(" %02X",pbHashValue[i]);
			//	printf("\n");
			//	printf("Signed Hash : ");
			//	for(int i=0; i<20; i++) printf(" %02X",pbMessage[i]);
			//	printf("\n");
			//}
			return 0;
		}
	}
	printf("GENUINE");
	return 0;
}

